"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _l7Core = require("@antv/l7-core");

var _inversify = require("inversify");

require("reflect-metadata");

var _BaseLayer = _interopRequireDefault(require("../tile/tileLayer/BaseLayer"));

var _dec, _class;

var LayerModelPlugin = (
/**
 * Layer Model 初始化，更新，销毁
 */
_dec = (0, _inversify.injectable)(), _dec(_class = /*#__PURE__*/function () {
  function LayerModelPlugin() {
    (0, _classCallCheck2.default)(this, LayerModelPlugin);
  }

  (0, _createClass2.default)(LayerModelPlugin, [{
    key: "build",
    value: function () {
      var _build = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(layer) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // 更新Model 配置项
                layer.prepareBuildModel(); // 初始化 Model

                _context.next = 3;
                return layer.buildModels();

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function build(_x) {
        return _build.apply(this, arguments);
      }

      return build;
    }()
  }, {
    key: "initLayerModel",
    value: function () {
      var _initLayerModel = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2(layer) {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.build(layer);

              case 2:
                layer.styleNeedUpdate = false;

              case 3:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function initLayerModel(_x2) {
        return _initLayerModel.apply(this, arguments);
      }

      return initLayerModel;
    }()
  }, {
    key: "prepareLayerModel",
    value: function () {
      var _prepareLayerModel = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3(layer) {
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.build(layer);

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function prepareLayerModel(_x3) {
        return _prepareLayerModel.apply(this, arguments);
      }

      return prepareLayerModel;
    }()
  }, {
    key: "apply",
    value: function apply(layer) {
      var _this = this;

      layer.hooks.init.tapPromise('LayerModelPlugin', /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee4() {
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!layer.getSource().isTile) {
                  _context4.next = 4;
                  break;
                }

                layer.prepareBuildModel();
                layer.tileLayer = new _BaseLayer.default(layer);
                return _context4.abrupt("return");

              case 4:
                layer.log(_l7Core.IDebugLog.BuildModelStart, _l7Core.ILayerStage.INIT);
                _context4.next = 7;
                return _this.initLayerModel(layer);

              case 7:
                layer.log(_l7Core.IDebugLog.BuildModelEnd, _l7Core.ILayerStage.INIT);

              case 8:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      })));
      layer.hooks.beforeRenderData.tapPromise('LayerModelPlugin', /*#__PURE__*/function () {
        var _ref2 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee5(flag) {
          return _regenerator.default.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  if (flag) {
                    _context5.next = 2;
                    break;
                  }

                  return _context5.abrupt("return", false);

                case 2:
                  if (!layer.getSource().isTile) {
                    _context5.next = 5;
                    break;
                  }

                  layer.tileLayer = new _BaseLayer.default(layer);
                  return _context5.abrupt("return", false);

                case 5:
                  layer.log(_l7Core.IDebugLog.BuildModelStart, _l7Core.ILayerStage.UPDATE);
                  _context5.next = 8;
                  return _this.prepareLayerModel(layer);

                case 8:
                  layer.log(_l7Core.IDebugLog.BuildModelEnd, _l7Core.ILayerStage.UPDATE);
                  return _context5.abrupt("return", true);

                case 10:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5);
        }));

        return function (_x4) {
          return _ref2.apply(this, arguments);
        };
      }());
    }
  }]);
  return LayerModelPlugin;
}()) || _class);
exports.default = LayerModelPlugin;